from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, String, Int, Boolean

Rnalienstatistics_Bin_V0_1_0 = CommandToolBuilder(tool="RNAlienStatistics_bin", base_command=["RNAlienStatistics-bin"], inputs=[ToolInput(tag="in_alien_covariance_model_path", input_type=File(optional=True), prefix="--aliencovariancemodelpath", doc=InputDocumentation(doc="Path to alienCovarianceModelPath")), ToolInput(tag="in_alien_rna_z_path", input_type=File(optional=True), prefix="--alienrnazpath", doc=InputDocumentation(doc="Path to alienRNAzResult")), ToolInput(tag="in_alien_rna_code_path", input_type=File(optional=True), prefix="--alienrnacodepath", doc=InputDocumentation(doc="Path to alienRNAcodeResult")), ToolInput(tag="in_alien_cm_stat_path", input_type=File(optional=True), prefix="--aliencmstatpath", doc=InputDocumentation(doc="Path to aliencmstatResult")), ToolInput(tag="in_rf_am_covariance_model_path", input_type=File(optional=True), prefix="--rfamcovariancemodelpath", doc=InputDocumentation(doc="Path to rfamCovarianceModelPath")), ToolInput(tag="in_rf_am_fast_a_file_path", input_type=File(optional=True), prefix="--rfamfastafilepath", doc=InputDocumentation(doc="Path to rfamFastaFile")), ToolInput(tag="in_alien_fast_a_file_path", input_type=File(optional=True), prefix="--alienfastafilepath", doc=InputDocumentation(doc="Path to alienFastaFile")), ToolInput(tag="in_rf_am_model_name", input_type=String(optional=True), prefix="--rfammodelname", doc=InputDocumentation(doc="Rfam model name")), ToolInput(tag="in_rf_am_model_id", input_type=String(optional=True), prefix="--rfammodelid", doc=InputDocumentation(doc="Rfam model id")), ToolInput(tag="in_rf_am_threshold", input_type=Int(optional=True), prefix="--rfamthreshold", doc=InputDocumentation(doc="Bitscore threshold for Rfam model hits\non Alien fasta, default 20")), ToolInput(tag="in_alien_threshold", input_type=Int(optional=True), prefix="--alienthreshold", doc=InputDocumentation(doc="Bitscore threshold for RNAlien model\nhits on Rfam fasta, default 20")), ToolInput(tag="in_database_size", input_type=Int(optional=True), prefix="--databasesize", doc=InputDocumentation(doc="Cmsearch database size in mega bases.\ndefault not set")), ToolInput(tag="in_output_directory_path", input_type=File(optional=True), prefix="--outputdirectorypath", doc=InputDocumentation(doc="Path to output directory")), ToolInput(tag="in_benchmark_index", input_type=Int(optional=True), prefix="--benchmarkindex", doc=InputDocumentation(doc="Index used to identify sRNA tagged RNA")), ToolInput(tag="in_link_scores", input_type=Boolean(optional=True), prefix="--linkscores", doc=InputDocumentation(doc="Triggers computation of linkscores via")), ToolInput(tag="in_verbose", input_type=Boolean(optional=True), prefix="--verbose", doc=InputDocumentation(doc="Loud verbosity")), ToolInput(tag="in_quiet", input_type=Boolean(optional=True), prefix="--quiet", doc=InputDocumentation(doc="Quiet verbosity")), ToolInput(tag="in_families", input_type=String(), position=0, doc=InputDocumentation(doc="-s --thresholdselection=ITEM        Selection method, (bitscore, evalue),")), ToolInput(tag="in_cm_compare", input_type=String(), position=0, doc=InputDocumentation(doc="-c --threads=INT                    Number of available cpu slots/cores,"))], outputs=[ToolOutput(tag="out_output_directory_path", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output_directory_path", type_hint=File()), doc=OutputDocumentation(doc="Path to output directory"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Rnalienstatistics_Bin_V0_1_0().translate("wdl", allow_empty_container=True)

